%  Alg3.m
function [x,J,fx,Dinv,msg,dual,j,alg] = Alg3  ...
    (c,C,n,m,r,tol,x,J,Dinv,A,b)
%  Alg3 implements QP Algorithn 3 to solve a model
%  Quadratic Programming Problem.

%  Initialization
alg = 'Algorithm 3';
msg = '';
dual = [];
fx = c'*x + 0.5*( x'*C*x);
g = c + C*x;
next = 'Step1';
for j=0:10000;
    if strcmp(next,'Step1')
        [next,k,s,msg,dual,big] = Step1(J,next,g,Dinv,n,m,r,tol);
        if strcmp(msg,'Optimal solution obtained')
            return
        end    

    end
    
    if strcmp(next,'Step2')
        [next,sigma,sigtil,sighat,ell,stCs,msg] = ...
                     Step2(J,m,A,b,C,s,tol,big,x);
        if strcmp(msg,'Unbounded from below');
            return
        end    
    end    
    
    if strcmp(next,'Step3')
                                            %  Step 3: Update
        x = x - sigma*s;
        g = c + C*x;
        fx = c'*x + 0.5*( x'*C*x);
        if sigtil <= sighat
            next = 'Step3p1';
        else
            next = 'Step3p2';
        end
        if strcmp(next,'Step3p1')
                                            %  Step 3.1
            d = stCs^(-.5) * C * s;
            [Dinv] = Phi1(Dinv,d,k,J,n);    % k is from Step 1
            J(k) = -1;
            next = 'Step1';
        end
        if strcmp(next,'Step3p2')
                                            % Step 3.2
            [Dinv] =  Phi(Dinv,A(ell,:)',k,n);
            for i = 1:n
                if J(i) == -1;
                    J(i) = 0;
                end
            end
            J(k) = ell;
            next = 'Step1';
        end
    end
    
end    % iteration loop for j

end



