%  Alg4.m
function [x,J,fx,Dinv,msg,dual,j,alg] = ...
                          Alg4(c,C,n,m,r,tol,x,J,Dinv,A,b)
%  Alg4 implements QP Algorithn 4 to solve a model
%  Quadratic Programming Problem.

%  Initialization
alg = 'Algorithm 4';
fx = c'*x + 0.5*( x'*C*x);
g = c + C*x;
next = 'Step1';
for j=0:10000;
    if strcmp(next,'Step1')
        [next,k,s,msg,dual,big] = ...
                      Step1(J,next,g,Dinv,n,m,r,tol);
        if strcmp(msg,'Optimal solution obtained')
            return
        end    

    end
    
    if strcmp(next,'Step2')
        [next,sigma,sigtil,sighat,ell,stCs,msg] = ...
                     Step2(J,m,A,b,C,s,tol,big,x);
        if strcmp(msg,'Unbounded from below');
            return
        end    
    end    
    
    if strcmp(next,'Step3')
                                         %  Step 3: Update
        x = x - sigma*s;
        g = c + C*x;
        fx = c'*x + 0.5*( x'*C*x);
        if sigtil <= sighat
            next = 'Step3p1';
        else
            next = 'Step3p2';
        end
    end    
    if strcmp(next,'Step3p1')
                                         %  Step 3.1
        d = stCs^(-.5) * C * s;
        [Dinv] = Phi1(Dinv,d,k,J,n);     % k is from Step 1
        J(k) = -1;
        next = 'Step1';                  % end of Step 3.1               
    end
        
    if strcmp(next,'Step3p2')
                                         % Step 3.2
        list = find( J == -1);
        big = -1.;
        for i=1:length(list)
            dotprod = abs( A(ell,:)*Dinv(:,list(i)) );
            if dotprod > big
                big = dotprod;
            end
        end
        if big >= 1.e-6
            next = 'Step3p3';
        end
        if strcmp(next,'Step3p2')
            [Dinv] =  Phi1(Dinv,A(ell,:)',k,J,n);
            J(k) = ell;
            next = 'Step1';
        end
    end
        
    if strcmp(next,'Step3p3')
                                         %  Step 3.3
        big = -1;
        nu = 0;
        for i=1:length(list)
            dotprod = abs( A(ell,:)*Dinv(:,list(i)) ) ;
            if dotprod > big
                big = dotprod;
                nu = list(i);
            end
        end
        [Dhatinv] = Phi2(Dinv,A(ell,:)',nu,J,n);
        [Dinv] = Phi1(Dhatinv,A(ell,:)',nu,J,n);
        J(nu) = ell;
        J(k) = 0;
        next = 'Step1';
    end
    
end    % iteration loop for j

end



