%    Alg6a.m
function [x,K,fx,Hinv,msg,dual,iter,alg] = ...
                      Alg6a(c,C,n,m,r,tol,x,K,actineq,A,b)
%   Alg6a is an implementation of the general Alg6 QP 
%   algorithm where the matrix inverse updating is done
%   using Procedures Psi1, Psi2 and Psi3.
%   Initialization
alg = 'Algorithm 6a';
fx = c'*x + 0.5*( x'*C*x);
g = c + C*x;
Aj = vertcat(A(K,:));
H = vertcat([C,Aj'],[Aj,zeros(actineq+r,actineq+r)]);
Hinv = inv(H);
singular = 'false';
next = 'Step1';
for iter=0:10000
    if strcmp(next,'Step1') 
                             % Step 1
        if strcmp(singular,'false')
            next = 'Step1p1';
        else
            next = 'Step1p2';
        end
    end    
    if strcmp(next,'Step1p1')
                             %  Step 1.1
        rhs = vertcat(g,zeros(actineq+r,1));
        sv = Hinv*rhs;
        s = sv(1:n);
        v = sv(n+1:n+actineq);         
        gamma = 0;
        next = 'Step2';
    end    
    if strcmp(next,'Step1p2')
                             % Step 1.2 
        s = w(1:n);
        s = 1./(A(kay,:)*s)*s;
        gamma = 1;
        next = 'Step2';
    end
    if strcmp(next,'Step2')
                             % Step 2
        if gamma == 0; 
            sigtilde = 1.;
        end
        if gamma == 1
            sigtilde = Inf;
        end
        sighat = Inf;
        ell = 0;
        for i=1:m
            if ~ ismember(i,K)
                temp = A(i,:)*s;
                if temp <0
                    test = (A(i,:)*x - b(i))/temp;
                    if test <= sighat
                        sighat = test;
                        ell = i;
                    end
                end
            end    
        end      %end for loop 
        if sigtilde == Inf & sighat == Inf
            msg = 'objective function is inbounded from below';
            return
        else
            sigma = min(sigtilde,sighat);
            next = 'Step3';
        end
    end    
    if strcmp(next,'Step3')
                             % Step 3
        x = x - sigma*s;
        fx = c'*x + 0.5*( x'*C*x);
        g = c + C*x;
        if sigma == sighat
            next = 'Step3p1';
        else
            next = 'Step3p2';
        end    
        if strcmp(next,'Step3p1')
                             % Step 3.1
            if strcmp(singular,'false')                 
                p = n + actineq + r;
                q = n + actineq;
                d1 = vertcat(A(ell,:)',zeros(actineq-1));
                gamma = 0.;
                d2 = zeros(actineq+r,1);
                [ Hinv,singular,w ] = ...
                    Psi1 ( Hinv,d1,gamma,d2,p,q );
                K1 = K(1:actineq);
                K2 = K(actineq+1:actineq+r);
                K = horzcat(K1,ell,K2);
                actineq = actineq +1;
                next = 'Step1p1';
            else            % singular = 'true'    
                posn = find(kay==K);
                d = vertcat( (A(ell,:)-A(kay,:))', ...
                                     zeros(actineq+r,1));
                p = n + actineq + r;
                q = n + posn;
                [Hinv] = Psi3(Hinv,d,p,q);
                K(posn) = ell;
                singular = 'false';
                next = 'Step1p1';
            end
        end    
        if strcmp(next,'Step3p2')
            u = zeros(m,1);
            for i=1:actineq
                u(K(i)) = - v(i);
            end
            minmult = min(u);
            kay = find(u == minmult,1);
            if minmult >= - tol
                dual = zeros(m+r,1);
                vv = sv(n+1:n+actineq+r);         
                for i=1:actineq+r
                    dual(K(i)) = - vv(i);
                end    
                msg = 'Optimal solution obtained';            
                return 
            end 
            posn = find(kay==K);
            [ Hinv,singular,w ] = ...
                          Psi2 ( Hinv,n+actineq+r,n+posn );
            if strcmp(singular,'false')          
                K(posn) = [];
                actineq = actineq - 1;
            end    
            next = 'Step1';
        end
    end    
end                    % end of for iter loop    