%  LPAlg3.m
function [x,J,fx,Dinv,msg,dual] = LPAlg3(c,n,m,r,  ...
                                         tol,x,J,Dinv,A,b)
%  LPAlg3 implements LP Algorithn 3 to solve a model
%  Linear Programming Problem.

%  Initialization
fx = c'*x;
for j=0:10000;
    %  Step 1: Computation of Search Direction s (= s_j)
    %  nzero = # components of J having value 0
    nzerolist = find(J == 0);
    nzero = length(nzerolist);
    if nzero >= 1
        % Step 1.1
        dotprod = abs(c'* Dinv(:,nzerolist) );
        big = max(dotprod);
        k = nzerolist(find(big==dotprod,1));
        gjckj = c'* Dinv(:,k); 
        % get the correct sign for gjckj
        if gjckj > 0.;
            s = Dinv(:,k);
        elseif gjckj <= 0.
            s = - Dinv(:,k);
        end

    elseif nzero == 0
        % Step 1.2
        n12mlist = find(J >= 1 & J <= m);
        n12m = length(n12mlist);
        %  n12m = # components of J having value between 
        %                         1 and m
        
        
        if n12m == 0;
            % We have an optimal solution
            msg = 'Optimal solution obtained';
            [dual] = GetDual(Dinv,J,c,n,m,r);
            return
        end
        
        if n12m >= 1
            dotprod = c'* Dinv(:,n12mlist);
            big = max(dotprod);
            k = n12mlist(find(big==dotprod,1));
        end
        
        if big <= tol
            %  Opimal Solution Obtained
            msg = 'Optimal solution obtained';
            [dual] = GetDual(Dinv,J,c,n,m,r);
            return
        else
            s = Dinv(:,k);
        end
    end  % end of if nzero >= 1
    
    %  Step 2 of LP  Algorihm 3
    %  maximum feasible step size (sighat)
    inactive = setdiff(1:m,J);
    sums = A(inactive,:)*s;
    ind =  find(sums<-tol);
    if size(ind,1)>0
        sigtest = (-b(inactive(ind))+A(inactive(ind),:)*x) ...
            ./sums(ind);
        sighat = min(sigtest);
        ell=inactive(ind(find(sigtest==sighat,1)));
    else
        sighat = Inf
    end
    if sighat == Inf
        msg = 'unbounded from below';
    return
    end
        
    sigma = sighat;
    
    %  Step 3: Update
    x = x - sigma*s;
    fx = c'*x ;
    [Dinv] =  Phi(Dinv,A(ell,:)',k,n);
    J(k) = ell;
    
end    % iteration loop for j
end