%  P1P2.m
function [A1,B1,C1,n1,m1,x,J,Dinv,dual,j,alg,fx,msg] =  ...
                                     P1P2(A,b,C,c,n,m,r)
%  This is the Pase 1 - Phase 2 routine.  It formulates 
%  the Phase 1 problem, solves it with a call to
%  LPAlg3 and then solves the given QP it using this 
%  starting point and QPAlg3
%
%  zero out d which is necessary if r = 0

d = zeros(n,1);

%  replace equalities with their negatives if rhs < 0

if r > 0
    for i=1:r
        if b(m+i) < 0
            A(m+i,:) = - A(m+i,:);
            b(m+i) = - b(m+i);
        end
    end
    for i=1:r
        d = d - A(m+i,:)';
    end
end    % end of if r > 0
n1 = n + 1;
m1 = m + r + 1;
r1 = 0;

for i=1:m+r
    for j=1:n
        A1(i,j) = A(i,j);
    end
end
for i=1:m
    A1(i,n1) = - 1.;
end
if r >= 1
    for i=(m+1):(m+r)
        A1(i,n1) = 0.;
    end
end
for j=1:n
    A1(m1,j) = 0;
end
A1(m1,n1) = -1;
if r >= 1
    for j=1:n
        C1(j) = d(j);
    end
end
if r == 0
    for j=1:n
        C1(j) = 0.0;
    end
end
C1(n1) = 1.;
for i= 1:m
    B1(i) = b(i);
end
if r >= 1
    for i = 1:r
        B1(m+i) = b(m+i);
    end
end
B1(m1) = 0.;

r1 = 0;
tol = 1.e-6;
for i =1:n
    x(i) = 0.;
end
big = 0.;
for j=1:m
    if - b(i) > big
        big = - b(i);
    end
end
x(n1) = big;
D0inv = eye(n1);
for i=1:n1
    J(i) = 0;
end

C1 = C1';
x = x';
B1 = B1';
%  We now have the Phase 1 problem data formulated.
%  Solve it using LPAlg3

[x,J,fx,D0inv,msg,dual] = LPAlg3(C1,n1,m1,r1,tol,x,J,  ...
                                           D0inv,A1,B1);
Dinv = D0inv;
for i = 1:n1
    if J(i) == m1;
        index = i;
    end
end
J(index) = [];
D0inv(:,index) = [];
D0inv(n1,:) = [];
x(n1) = [];
%  solve the QP using Alg 3
[x,J,fx,Dinv,msg,dual,j,alg] = Alg3(c,C,n,m,r,tol,x,J,  ...
                                             D0inv,A,b);
alg = 'Phase 1 - Phase 2';
